3 USAGE='[start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
7 mark <rev> a known-bad revision.
8 git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
10 git bisect skip [<rev>...]
11 mark <rev>... untestable revisions.
13 find next bisection to test and check it out.
14 git bisect reset [<branch>]
15 finish bisection search and go back to branch.
17 show bisect status in gitk.
18 git bisect replay <logfile>
22 git bisect run <cmd>...
23 use <cmd>... to automatically bisect.'
29 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
30 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35 s/'\''/'\'\\\\\'\''/g;
43 test -f "$GIT_DIR/BISECT_NAMES" || {
44 echo >&2 'You need to start by "git bisect start"'
47 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
62 # Verify HEAD. If we were bisecting before this, reset to the
63 # top-of-line master first!
65 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref HEAD) ||
66 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
67 die "Bad HEAD - I need a HEAD"
70 if [ -s "$GIT_DIR/head-name" ]; then
71 branch=`cat "$GIT_DIR/head-name"`
75 git checkout $branch || exit
78 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
79 echo "${head#refs/heads/}" >"$GIT_DIR/head-name"
82 die "Bad HEAD - strange symbolic ref"
87 # Get rid of any old bisect state
92 # Check for one bad and then some good revisions.
96 case "$arg" in --) has_double_dash=1; break ;; esac
100 while [ $# -gt 0 ]; do
108 rev=$(git rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
109 test $has_double_dash -eq 1 &&
110 die "'$arg' does not appear to be a valid revision"
114 0) state='bad' ; bad_seen=1 ;;
117 bisect_write "$state" "$rev" 'nolog'
123 sq "$@" >"$GIT_DIR/BISECT_NAMES"
124 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
134 good|skip) tag="$state"-"$rev" ;;
135 *) die "Bad bisect_write argument: $state" ;;
137 git update-ref "refs/bisect/$tag" "$rev"
138 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
139 test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
147 die "Please call 'bisect_state' with at least one argument." ;;
149 rev=$(git rev-parse --verify HEAD) ||
150 die "Bad rev input: HEAD"
151 bisect_write "$state" "$rev" ;;
153 rev=$(git rev-parse --verify "$2^{commit}") ||
154 die "Bad rev input: $2"
155 bisect_write "$state" "$rev" ;;
158 revs=$(git rev-parse --revs-only --no-flags "$@") &&
159 test '' != "$revs" || die "Bad rev input: $@"
162 rev=$(git rev-parse --verify "$rev^{commit}") ||
163 die "Bad rev commit: $rev^{commit}"
164 bisect_write "$state" "$rev"
172 bisect_next_check() {
173 missing_good= missing_bad=
174 git show-ref -q --verify refs/bisect/bad || missing_bad=t
175 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
177 case "$missing_good,$missing_bad,$1" in
179 : have both good and bad - ok
182 # do not have both but not asked to fail - just report.
186 # have bad but not good. we could bisect although
187 # this is less optimum.
188 echo >&2 'Warning: bisecting only with a bad commit.'
191 printf >&2 'Are you sure [Y/n]? '
192 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
194 : bisect without good...
198 test -f "$GIT_DIR/BISECT_NAMES" || {
199 echo >&2 'You need to start by "git bisect start".'
202 echo >&2 'You '$THEN'need to give me at least one good' \
203 'and one bad revisions.'
204 echo >&2 '(You can use "git bisect bad" and' \
205 '"git bisect good" for that.)'
211 bisect_next_check && bisect_next || :
218 if [ -z "$_skip" ]; then
223 # Let's parse the output of:
224 # "git rev-list --bisect-vars --bisect-all ..."
225 eval $_eval | while read hash line
227 case "$VARS,$FOUND,$TRIED,$hash" in
228 # We display some vars.
229 1,*,*,*) echo "$hash $line" ;;
234 # We had nothing to search.
240 # We did not find a good bisect rev.
241 # This should happen only if the "bad"
242 # commit is also a "skip" commit.
244 echo "bisect_rev=$TRIED"
250 TRIED="${TRIED:+$TRIED|}$hash"
254 echo "bisect_rev=$hash"
255 echo "bisect_tried=\"$TRIED\""
261 # We have already found a rev to be tested.
262 ,1,*,bisect_rev*) VARS=1 ;;
266 *) die "filter_skipped error " \
277 exit_if_skipped_commits () {
279 if expr "$_tried" : ".*[|].*" > /dev/null ; then
280 echo "There are only 'skip'ped commit left to test."
281 echo "The first bad commit could be any of:"
282 echo "$_tried" | tr '[|]' '[\012]'
283 echo "We cannot bisect more!"
289 case "$#" in 0) ;; *) usage ;; esac
291 bisect_next_check good
293 skip=$(git for-each-ref --format='%(objectname)' \
294 "refs/bisect/skip-*" | tr '[\012]' ' ') || exit
297 test -n "$skip" && BISECT_OPT='--bisect-all'
299 bad=$(git rev-parse --verify refs/bisect/bad) &&
300 good=$(git for-each-ref --format='^%(objectname)' \
301 "refs/bisect/good-*" | tr '[\012]' ' ') &&
302 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
303 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
304 eval=$(filter_skipped "$eval" "$skip") &&
307 if [ -z "$bisect_rev" ]; then
308 echo "$bad was both good and bad"
311 if [ "$bisect_rev" = "$bad" ]; then
312 exit_if_skipped_commits "$bisect_tried"
313 echo "$bisect_rev is first bad commit"
314 git diff-tree --pretty $bisect_rev
318 # We should exit here only if the "bad"
319 # commit is also a "skip" commit (see above).
320 exit_if_skipped_commits "$bisect_rev"
322 echo "Bisecting: $bisect_nr revisions left to test after this"
323 git branch -f new-bisect "$bisect_rev"
324 git checkout -q new-bisect || exit
325 git branch -M new-bisect bisect
326 git show-branch "$bisect_rev"
330 bisect_next_check fail
334 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
341 -*) set git log "$@" ;;
346 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
347 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
351 test -f "$GIT_DIR/BISECT_NAMES" || {
352 echo "We are not bisecting."
356 0) if [ -s "$GIT_DIR/head-name" ]; then
357 branch=`cat "$GIT_DIR/head-name"`
361 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
362 die "$1 does not seem to be a valid branch"
367 if git checkout "$branch"; then
368 rm -f "$GIT_DIR/head-name"
373 bisect_clean_state() {
374 # There may be some refs packed during bisection.
375 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* refs/heads/bisect |
378 git update-ref -d $ref $hash
380 rm -f "$GIT_DIR/BISECT_LOG"
381 rm -f "$GIT_DIR/BISECT_NAMES"
382 rm -f "$GIT_DIR/BISECT_RUN"
386 test -r "$1" || die "cannot read $1 for replaying"
388 while read bisect command rev
390 test "$bisect" = "git-bisect" || continue
393 cmd="bisect_start $rev"
396 bisect_write "$command" "$rev" ;;
398 die "?? what are you talking about?" ;;
405 bisect_next_check fail
413 # Check for really bad run error.
414 if [ $res -lt 0 -o $res -ge 128 ]; then
415 echo >&2 "bisect run failed:"
416 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
420 # Find current state depending on run success or failure.
421 # A special exit code of 125 means cannot test.
422 if [ $res -eq 125 ]; then
424 elif [ $res -gt 0 ]; then
430 # We have to use a subshell because "bisect_state" can exit.
431 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
434 cat "$GIT_DIR/BISECT_RUN"
436 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
438 echo >&2 "bisect run cannot continue any more"
442 if [ $res -ne 0 ]; then
443 echo >&2 "bisect run failed:"
444 echo >&2 "'bisect_state $state' exited with error code $res"
448 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
449 echo "bisect run success"
467 bisect_state "$cmd" "$@" ;;
469 # Not sure we want "next" at the UI level anymore.
472 bisect_visualize "$@" ;;
476 bisect_replay "$@" ;;
478 cat "$GIT_DIR/BISECT_LOG" ;;